
-- =================================================================================
--                          TauntMaster2                                          ==
--          http://www.curse.com/addons/wow/taunt-master-2                        ==
--                                                                                ==
-- =================================================================================
-- Author      : Tartarusspawn
-- Create Date : 6/14/2015 9:14:11 PM

local Spacer = "    "
function tm2DrawConfig()


	-- =======================================================
	-- Interface Gui
	-- =======================================================

	local panel = CreateFrame("FRAME", "TauntMasterPanel");
	panel.name = GetAddOnMetadata("TauntMaster2", "Title")
	InterfaceOptions_AddCategory(panel);

	panel.Options = CreateFrame("FRAME", "Options",panel);
	panel.Options.name = "Options";
	panel.Options.parent = panel.name
	InterfaceOptions_AddCategory(panel.Options);

	panel.Left = CreateFrame("FRAME", "LeftMouseButton",panel);
	panel.Left.name = Spacer .. "Left Button";
	panel.Left.parent = panel.name
	InterfaceOptions_AddCategory(panel.Left,panel.name);

	panel.Right = CreateFrame("FRAME", "RightMouseButton",panel);
	panel.Right.name = Spacer .. "Right Button";
	panel.Right.parent = panel.name
	InterfaceOptions_AddCategory(panel.Right);

	panel.Middle = CreateFrame("FRAME", "MiddleMouseButton",panel);
	panel.Middle.name = Spacer .. "Middle Button";
	panel.Middle.parent = panel.name
	InterfaceOptions_AddCategory(panel.Middle);

	panel.Button4 = CreateFrame("FRAME", "Button4MouseButton",panel);
	panel.Button4.name = Spacer .. "Button4 Button";
	panel.Button4.parent = panel.name
	InterfaceOptions_AddCategory(panel.Button4);

	panel.Button5 = CreateFrame("FRAME", "Button5MouseButton",panel);
	panel.Button5.name = Spacer .. "Button5 Button";
	panel.Button5.parent = panel.name
	InterfaceOptions_AddCategory(panel.Button5);

	local RaidBosses = CreateFrame("FRAME", "RaidBosses",panel);
	RaidBosses.name = GetAddOnMetadata("TauntMaster2", "Title") .. " Raid";
	InterfaceOptions_AddCategory(RaidBosses);

	local WorldBosses = CreateFrame("FRAME", "WorldBosses",panel);
	WorldBosses.name = GetAddOnMetadata("TauntMaster2", "Title") .. " World";
	InterfaceOptions_AddCategory(WorldBosses);
	
	-- =======================================================
	-- Interface 
	--
	-- panel
	-- =======================================================
	
	local Title = panel:CreateFontString (nil, "ARTWORK", "GameFontNormalLarge")
	Title:SetPoint ("TOP", 0, -16)
	Title:SetText (GetAddOnMetadata("TauntMaster2", "Title"))
	panel.Title = "Title"
	
	-- =======================================================
	-- Interface Options
	--
	-- panel.Options
	-- =======================================================
	local GuiOptionLoc = -16

	-- GuildDonationHelper2.panel
	local Title = panel.Options:CreateFontString (nil, "ARTWORK", "GameFontNormalLarge")
	Title:SetPoint ("TOP", 0, GuiOptionLoc)
	Title:SetText (GetAddOnMetadata("TauntMaster2", "Title") .. " Options")
	panel.Options.Title = "Title"

	GuiOptionLoc = GuiOptionLoc - 30
	local SliderTm2Scale = CreateFrame("Slider", "TM2 Scale" , panel.Options, "OptionsSliderTemplate")
	SliderTm2Scale:ClearAllPoints()
	SliderTm2Scale:SetWidth (500)
	SliderTm2Scale:SetPoint ("TOPLEFT", 8, GuiOptionLoc)
	SliderTm2Scale:SetMinMaxValues(1, 200)
	SliderTm2Scale:SetValueStep(1)
	SliderTm2Scale:SetObeyStepOnDrag(true)
	SliderTm2Scale:SetValue(TauntMaster2.db.char.gui.scale * 100)
	_G["TM2 Scale" .."Low"]:SetText("0");
	_G["TM2 Scale" .."High"]:SetText("200");
	_G["TM2 Scale" .."Text"]:SetText("TM2 Scale" ..":  ".. TauntMaster2.db.char.gui.scale * 100 .. " %");
	SliderTm2Scale:SetScript("OnValueChanged", function(self,tm2scalevalue)
		TauntMaster2.db.char.gui.scale=tm2scalevalue /100
		TauntMasterUnitFrames_Header:SetScale(TauntMaster2.db.char.gui.scale)
		_G["TM2 Scale" .."Text"]:SetText("TM2 Scale" ..":  ".. TauntMaster2.db.char.gui.scale * 100 .. " %" );
	end);
	SliderTm2Scale:Show()

	-- =======================================================
	-- LeftButton	
	--
	-- panel.Left
	-- =======================================================

	if not LeftButtonDropDown then 
		CreateFrame("FRAME", "LeftButtonDropDown",  panel.Left , "UIDropDownMenuTemplate")
	end

	LeftButtonDropDown:ClearAllPoints()
	LeftButtonDropDown:SetPoint("TOPLEFT", 50, -100)
	LeftButtonDropDown:Show()
	
	UIDropDownMenu_Initialize(LeftButtonDropDown, Left_Spell_initialize)
	UIDropDownMenu_SetWidth(LeftButtonDropDown, 125)
	UIDropDownMenu_SetButtonWidth(LeftButtonDropDown, 124)
	UIDropDownMenu_SetText(LeftButtonDropDown, TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"])
	
	-- =======================================================
	-- RightButton	
	--
	-- panel.Right
	-- =======================================================
	if not RightButtonDropDown then 
		CreateFrame("FRAME", "RightButtonDropDown",  panel.Right , "UIDropDownMenuTemplate")
	end

	RightButtonDropDown:ClearAllPoints()
	RightButtonDropDown:SetPoint("TOPLEFT", 50, -100)
	RightButtonDropDown:Show()
	
	UIDropDownMenu_Initialize(RightButtonDropDown, Right_Spell_initialize)
	UIDropDownMenu_SetWidth(RightButtonDropDown, 125)
	UIDropDownMenu_SetButtonWidth(RightButtonDropDown, 124)
	UIDropDownMenu_SetText(RightButtonDropDown, TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["RightButton"])
end


function Left_Spell_initialize(self,level)
	local info 
	local tm2numTabs = GetNumSpellTabs()

	for BookTabs = 1,tm2numTabs do
		local name,texture,offset,numSpells = GetSpellTabInfo(BookTabs)
		
		local currentSpec = GetSpecialization()
		local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or select(1, UnitClass("player"))

		if BookTabs == 1 or name == currentSpecName  then
			if level == 1 then
				info = UIDropDownMenu_CreateInfo()
				info.text = (name .. " Submenu")
				info.value = name
				info.isTitle = true
				info.hasArrow = true
				UIDropDownMenu_AddButton(info, level)
			end
		end
		--print("Spell tab \"" .. name .. "\" contains spells from id " .. offset + 1 .. " through " .. offset + numSpells)
		for BookSpells = offset + 1,offset + numSpells do
			--TauntMaster2.db.char.Spellbook[name] = TauntMaster2.db.char.Spellbook[name] or {}

			local skillName = GetSpellBookItemName(BookSpells, "spell")

			if BookTabs <=5 then
				if (IsAttackSpell(BookSpells, "spell"))  then
					--print(tmpspellid , skillName )
				end
			end
			if ((IsHarmfulSpell(BookSpells, "spell") or IsHelpfulSpell(BookSpells, "spell")) and not (IsPassiveSpell(BookSpells, "spell"))) or (IsAttackSpell(BookSpells, "spell"))  then 
				
				if (IsSpellKnown(select(7, GetSpellInfo(BookSpells, "spell"))) ) then
					if level == 2 and UIDROPDOWNMENU_MENU_VALUE == name then
						info = UIDropDownMenu_CreateInfo()
						info.text = skillName

						if info.text == TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] then
							info.checked = true
						else
							info.checked = false
						end
						function info.func(button)
							TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] = skillName
							UIDropDownMenu_SetText(LeftButtonDropDown, TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"])
							--TauntMasterUnitFrames_Header.Spell1:SetTexture(select(3, GetSpellInfo(TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"])))
							print(TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] )
							print(button)
						end
						UIDropDownMenu_AddButton(info, level)
					end

				end
				--UIDropDownMenu_AddButton(info, name)
			end
			
		end
		
	end

	local numAccountMacros, numCharacterMacros = GetNumMacros()
	if level == 1 then
		info = UIDropDownMenu_CreateInfo()
		info.text = ("Account Macros Submenu")
		info.value = "Account Macros"
		info.isTitle = true
		info.hasArrow = true
		UIDropDownMenu_AddButton(info, level)

		info = UIDropDownMenu_CreateInfo()
		info.text = ("CharacterMacros Submenu")
		info.value = "CharacterMacros"
		info.isTitle = true
		info.hasArrow = true
		UIDropDownMenu_AddButton(info, level)
		
	end

	for MacroInfo =1,numAccountMacros do
		local name = select(1,GetMacroInfo(MacroInfo) )
		if level == 2 and UIDROPDOWNMENU_MENU_VALUE == "Account Macros" then
			info = UIDropDownMenu_CreateInfo()
			info.text = name
			info.isTitle = true
			if info.text == TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] then
				info.checked = true
			else
				info.checked = false
			end
			function info.func(button)
				TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] = name
				UIDropDownMenu_SetText(LeftButtonDropDown, TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"])
				--TauntMasterUnitFrames_Header.Spell1:SetTexture(select(3, GetSpellInfo(TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"])))
				print(TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] )
				print(button)
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end


	for i =1, numCharacterMacros do
	local cname = select(1,GetMacroInfo(MAX_ACCOUNT_MACROS +i ) )
	if level == 2 and UIDROPDOWNMENU_MENU_VALUE == "CharacterMacros" then
	info = UIDropDownMenu_CreateInfo()
	info.text = cname
	info.isTitle = true
	if info.text == TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] then
	info.checked = true
	else
	info.checked = false
	end
	function info.func(button)
	TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"] = cname
	UIDropDownMenu_SetText(LeftButtonDropDown, TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"])
	end
	UIDropDownMenu_AddButton(info, level)
	end
	end



end


function Right_Spell_initialize(self,level)
	local info 
	local tm2numTabs = GetNumSpellTabs()

	for BookTabs = 1,tm2numTabs do
		local name,texture,offset,numSpells = GetSpellTabInfo(BookTabs)
		
		local currentSpec = GetSpecialization()
		local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or select(1, UnitClass("player"))

		if BookTabs == 1 or name == currentSpecName  then
			if level == 1 then
				local info = UIDropDownMenu_CreateInfo()
				info.text = (name .. " Submenu")
				info.value = name
				info.isTitle = true
				info.hasArrow = true
				UIDropDownMenu_AddButton(info, level)
			end
		end
		--print("Spell tab \"" .. name .. "\" contains spells from id " .. offset + 1 .. " through " .. offset + numSpells)
		for BookSpells = offset + 1,offset + numSpells do
			--TauntMaster2.db.char.Spellbook[name] = TauntMaster2.db.char.Spellbook[name] or {}

			local skillName = GetSpellBookItemName(BookSpells, "spell")

			if BookTabs <=5 then
				if (IsAttackSpell(BookSpells, "spell"))  then
					--print(tmpspellid , skillName )
				end
			end
			if ((IsHarmfulSpell(BookSpells, "spell") or IsHelpfulSpell(BookSpells, "spell")) and not (IsPassiveSpell(BookSpells, "spell"))) or (IsAttackSpell(BookSpells, "spell"))  then 
				
				if (IsSpellKnown(select(7, GetSpellInfo(BookSpells, "spell"))) ) then
					if level == 2 and UIDROPDOWNMENU_MENU_VALUE == name then
						info = UIDropDownMenu_CreateInfo()
						info.text = skillName

						if info.text == TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["RightButton"] then
							info.checked = true
						else
							info.checked = false
						end
						function info.func(button)
							TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["RightButton"] = skillName
							UIDropDownMenu_SetText(RightButtonDropDown, TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["RightButton"])
							--TauntMasterUnitFrames_Header.Spell1:SetTexture(select(3, GetSpellInfo(TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["LeftButton"])))
							print(TauntMaster2.db.char.Spells[TauntMaster2.db.char.id]["RightButton"] )
							print(button)
						end
						UIDropDownMenu_AddButton(info, level)
					end

				end
				--UIDropDownMenu_AddButton(info, name)
			end
			
		end
		
	end

	local numAccountMacros, numCharacterMacros = GetNumMacros()
	if level == 1 then
		info = UIDropDownMenu_CreateInfo()
		info.text = ("Account Macros Submenu")
		info.value = name
		info.isTitle = true
		info.hasArrow = true
		UIDropDownMenu_AddButton(info, level)

		info = UIDropDownMenu_CreateInfo()
		info.text = ("CharacterMacros Submenu")
		info.value = name
info.isTitle = true
		info.hasArrow = true
		UIDropDownMenu_AddButton(info, level)
	end
	for i =1,numAccountMacros do


	end

end




















